package bsp.noten;

import java.io.FileReader;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

import org.apache.commons.csv.CSVFormat;
import org.apache.commons.csv.CSVParser;
import org.apache.commons.csv.CSVRecord;

public class CsvReader {

   public static List<SchuelerNote> readCsv(final String filePath) {
      final List<SchuelerNote> notenListe = new ArrayList<>();

      try (FileReader reader = new FileReader(filePath);
            CSVParser csvParser = new CSVParser(reader, CSVFormat.DEFAULT.withHeader())) {

         for (final CSVRecord record : csvParser) {
            final String name = record.get("Name");
            final String vorname = record.get("Vorname");
            final int note = Integer.parseInt(record.get("Note"));

            final SchuelerNote schuelerNote = new SchuelerNote(name, vorname, note);
            notenListe.add(schuelerNote);
         }

      } catch (final IOException e) {
         e.printStackTrace();
      }

      return notenListe;
   }
}
