package bsp.noten;

import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

public class NotenAnalyseLambda {

   public static void main(final String[] args) {
      final List<SchuelerNote> notenListe = CsvReader.readCsv("src/main/resources/noten.csv");

      // Sortierung und Ausgabe der Liste
      notenListe.stream().sorted().forEach(s -> System.out.println(s.getName() + ", " + s.getVorname() + ": "
            + s.getNote()));
      System.out.println("\n------------------------------");

      // Berechnung der Notenverteilung
      final Map<Integer, Long> notenVerteilung = notenListe.stream().collect(Collectors.groupingBy(SchuelerNote::getNote, Collectors.counting()));

      // Ausgabe der Notenverteilung
      final int gesamtAnzahl = notenListe.size();
      notenVerteilung.forEach((note, anzahl) -> {
         final double prozentsatz = anzahl / (double) gesamtAnzahl * 100;
         System.out.format("Note %d: %d Schüler (%.2f%%)%n", note, anzahl, prozentsatz);
      });
      System.out.println("\n------------------------------");

      // Gruppierung und Ausgabe
      final long gutesErgebnis = notenListe.stream().filter(s -> s.getNote() == 1 || s.getNote() == 2).count();
      final long ausreichendesErgebnis = notenListe.stream().filter(s -> s.getNote() == 3 || s.getNote() == 4).count();
      final long schlechtesErgebnis = notenListe.stream().filter(s -> s.getNote() == 5 || s.getNote() == 6).count();

      System.out.println("Gutes Ergebnis: " + gutesErgebnis + " Schüler");
      System.out.println("Ausreichendes Ergebnis: " + ausreichendesErgebnis + " Schüler");
      System.out.println("Schlechtes Ergebnis: " + schlechtesErgebnis + " Schüler");
   }
}
