package bsp.noten;

import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class NotenAnalyseLoop {

   public static void main(final String[] args) {

      final List<SchuelerNote> notenListe = CsvReader.readCsv("src/main/resources/noten.csv");

      // Sortierung nach Namen
      Collections.sort(notenListe);

      // Ausgabe der sortierten Liste
      for (final SchuelerNote note : notenListe) {
         System.out.println(note.getName() + ", " + note.getVorname() + ": " + note.getNote());
      }
      System.out.println("\n------------------------------");

      // Berechnung der Notenverteilung
      final Map<Integer, Integer> notenVerteilung = new HashMap<>();
      for (final SchuelerNote note : notenListe) {
         notenVerteilung.put(note.getNote(), notenVerteilung.getOrDefault(note.getNote(), 0) + 1);
      }

      // Ausgabe der Notenverteilung
      final int gesamtAnzahl = notenListe.size();
      for (final Map.Entry<Integer, Integer> entry : notenVerteilung.entrySet()) {
         final int anzahl = entry.getValue();
         final double prozentsatz = anzahl / (double) gesamtAnzahl * 100;
         System.out.format("Note %d: %d Schüler (%.2f%%)%n", entry.getKey(), anzahl, prozentsatz);
      }
      System.out.println("\n------------------------------");

      // Gruppierung der Noten
      int gutesErgebnis = 0, ausreichendesErgebnis = 0, schlechtesErgebnis = 0;
      for (final SchuelerNote note : notenListe) {
         if (note.getNote() == 1 || note.getNote() == 2) {
            gutesErgebnis++;
         } else if (note.getNote() == 3 || note.getNote() == 4) {
            ausreichendesErgebnis++;
         } else if (note.getNote() == 5 || note.getNote() == 6) {
            schlechtesErgebnis++;
         }
      }

      // Ausgabe der gruppierten Ergebnisse
      System.out.println("Gutes Ergebnis: " + gutesErgebnis + " Schüler");
      System.out.println("Ausreichendes Ergebnis: " + ausreichendesErgebnis + " Schüler");
      System.out.println("Schlechtes Ergebnis: " + schlechtesErgebnis + " Schüler");
   }
}
