package de.gc.model;

import java.util.Objects;

public class Ort implements Comparable<Ort> {

   private String ortsname;
   private String plz;
   private String bundesland;
   private String landkreis;
   private int einwohnerzahl;

   public Ort() {
      super();
   }

   public Ort(final String ortsname, final String plz, final String landkreis, final String bundesland,
         final int einwohnerzahl) {
      super();
      this.ortsname = ortsname;
      this.plz = plz;
      this.landkreis = landkreis;
      this.bundesland = bundesland;
      this.einwohnerzahl = einwohnerzahl;
   }

   /**
    * sortiert nach bundesland, landkreis, ortsname
    */
   @Override
   public int compareTo(final Ort o) {

      int rt = 0;
      rt = bundesland.compareTo(o.bundesland);
      if (rt == 0) {
         rt = landkreis.compareTo(o.landkreis);
         if (rt == 0) {
            rt = ortsname.compareTo(o.ortsname);
         }
      }
      return rt;
   }

   @Override
   public boolean equals(final Object obj) {
      if (this == obj) {
         return true;
      }
      if (obj == null) {
         return false;
      }
      if (getClass() != obj.getClass()) {
         return false;
      }
      final Ort other = (Ort) obj;
      return Objects.equals(bundesland, other.bundesland) && einwohnerzahl == other.einwohnerzahl
            && Objects.equals(landkreis, other.landkreis) && Objects.equals(ortsname, other.ortsname)
            && Objects.equals(plz, other.plz);
   }

   public String getBundesland() {
      return bundesland;
   }

   public int getEinwohnerzahl() {
      return einwohnerzahl;
   }

   public String getLandkreis() {
      return landkreis;
   }

   public String getOrtsname() {
      return ortsname;
   }

   public String getPlz() {
      return plz;
   }

   @Override
   public int hashCode() {
      return Objects.hash(bundesland, einwohnerzahl, landkreis, ortsname, plz);
   }

   public void setBundesland(final String bundesland) {
      this.bundesland = bundesland;
   }

   public void setEinwohnerzahl(final int einwohnerzahl) {
      this.einwohnerzahl = einwohnerzahl;
   }

   public void setLandkreis(final String landkreis) {
      this.landkreis = landkreis;
   }

   public void setOrtsname(final String ortsname) {
      this.ortsname = ortsname;
   }

   public void setPlz(final String plz) {
      this.plz = plz;
   }

   @Override
   public String toString() {
      return String.format("Ort [ortsname=%s, plz=%s, landkreis=%s, bundesland=%s, einwohnerzahl=%s]", ortsname, plz,
            landkreis, bundesland, einwohnerzahl);
   }

}
