package de.gc.model;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.Collection;

import org.apache.commons.csv.CSVFormat;
import org.apache.commons.csv.CSVParser;
import org.apache.commons.csv.CSVRecord;

public class PlzList extends ArrayList<Ort> {

   public PlzList() {
      super();
   }

   public PlzList(final Collection<? extends Ort> c) {
      super(c);
   }

   public PlzList(final int initialCapacity) {
      super(initialCapacity);
   }

   public PlzList(final String csvname) {
      super(13000);
      try (BufferedReader plzOrtReader = new BufferedReader(
            new InputStreamReader(getClass().getResourceAsStream(csvname)))) {

         final CSVParser records = CSVFormat.EXCEL.builder().setDelimiter(';').setQuote('"').setIgnoreEmptyLines(true)
               .setIgnoreSurroundingSpaces(true).setHeader().setSkipHeaderRecord(true).build().parse(plzOrtReader);
         for (final CSVRecord record : records) {
            final String ort = record.get(0).trim();
            final String plz = record.get(1).trim();
            final String landkreis = record.get(2).trim();
            final String bundesland = record.get(3).trim();
            int ieinwohner = 0;
            try {
               ieinwohner = Integer.parseInt(record.get(4).trim());
            } catch (final NumberFormatException e) {
               System.out.println("Einwohnerzahl konnte nicht in Integer umgewandelt werden: " + record.get(4));
            }
            final Ort o = new Ort(ort, plz, landkreis, bundesland, ieinwohner);
            add(o);
         }
         plzOrtReader.close();

      } catch (final Exception e) {
         e.printStackTrace();
      }
   }
}
