package de.gc.streams.einf;

import java.util.Collections;

import de.gc.model.Ort;
import de.gc.model.PlzList;
import de.gc.util.Util;

public class Lamda_03_filter_01 {

   public static void main(final String[] args) {
      final PlzList plzListe = new PlzList("/plz_orte.csv");

      final String BNAME = "Bayern";

      // 1: sortierte Ausgabe mit filter und for-Schleife
      long start = Util.getStartTime();
      final PlzList sortListe = new PlzList(plzListe);
      Collections.sort(sortListe);
      for (final Ort ort : sortListe) {
         if (ort.getBundesland().equals(BNAME)) {
            System.out.println(ort);
         }
      }
      final long time1 = Util.getTime(start);

      // 2: sortierte Ausgabe mit filter und stream, forEach
      start = Util.getStartTime();
      plzListe.stream().sorted().filter(o -> o.getBundesland().equals(BNAME)).forEach(System.out::println);
      final long time2 = Util.getTime(start);

      System.out.println("#######################");
      Util.printDiff(time1, "erster", time2, "zweiter");

   }
}
