package de.gc.streams.einf;

import java.util.Collections;
import java.util.List;
import java.util.stream.Collectors;

import de.gc.model.Ort;
import de.gc.model.PlzList;
import de.gc.util.Util;

public class Lamda_05_filter_03 {

   public static void main(final String[] args) {
      final PlzList plzListe = new PlzList("/plz_orte.csv");

      // @formatter:off
      final String BNAME = "Bayern";

      // 1: neue Liste: sortierte Ausgabe mit filter und for-Schleife
      long start = Util.getStartTime();
      final PlzList bayernListe = new PlzList();
      final PlzList sortListe = new PlzList(plzListe);
      Collections.sort(sortListe);
      for (final Ort ort : sortListe) {
         if (ort.getBundesland().equals(BNAME)) {
            bayernListe.add(ort);
         }
      }
      for (final Ort ort : bayernListe) {
         System.out.println(ort);
      }
      final long time1 = Util.getTime(start);

      // 2: neue Liste: sortierte Ausgabe mit filter und stream, forEach
      start = Util.getStartTime();
      final List<Ort> blist = plzListe.stream()
            .sorted().filter(o -> o.getBundesland().equals(BNAME))
            .collect(Collectors.toList());
      blist.forEach(System.out::println);
      final long time2 = Util.getTime(start);

      System.out.println("#######################");
      Util.printDiff(time1, "erster", time2, "zweiter");
      // @formatter:on
   }
}
