package de.gc.streams.einf;

import java.util.ArrayList;

import de.gc.model.Ort;
import de.gc.model.PlzList;
import de.gc.util.Util;

public class Lamda_06_distinct_01 {

   public static void main(final String[] args) {
      final PlzList plzListe = new PlzList("/plz_orte.csv");

      // @formatter:off
      // 1: distinct
      long start = Util.getStartTime();
      final ArrayList<String> bnamen = new ArrayList<>();
      for (final Ort ort : plzListe) {
         if (!bnamen.contains(ort.getBundesland())) {
            bnamen.add(ort.getBundesland());
         }
      }
      for (final String bn : bnamen) {
         System.out.println(bn);
      }
      final long time1 = Util.getTime(start);
      System.out.println("#######################");

      // 2: distinct mit stream
      start = Util.getStartTime();
      plzListe.stream().map(Ort::getBundesland)
         .distinct().forEach(System.out::println);
      final long time2 = Util.getTime(start);

      System.out.println("#######################");
      Util.printDiff(time1, "erster", time2, "zweiter");
      // @formatter:on
   }
}
