package de.gc.streams.einf;

import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

import de.gc.model.Ort;
import de.gc.model.PlzList;
import de.gc.util.Util;

public class Lamda_07_groupby_01 {

   public static void main(final String[] args) {
      final PlzList plzListe = new PlzList("/plz_orte.csv");

      final long start = Util.getStartTime();
      final Map<String, List<Ort>> map = plzListe.stream().collect(Collectors.groupingBy(Ort::getBundesland));

      map.keySet().stream().forEach(key -> {
         System.out.format("--- %s --------------------%n", key);
         final List<Ort> bort = map.get(key);
         bort.stream().sorted((o1, o2) -> Integer.compare(o1.getEinwohnerzahl(), o2.getEinwohnerzahl()))
               .forEach(System.out::println);
      });
      System.out.println("#######################");
      Util.printTime(start);
   }
}