package de.gc.streams.einf;

import java.util.Comparator;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

import de.gc.model.Ort;
import de.gc.model.PlzList;
import de.gc.util.Util;

public class Lamda_08_groupby_02 {

   public static void main(final String[] args) {
      final PlzList plzListe = new PlzList("/plz_orte.csv");

      // @formatter:off
      final long start = Util.getStartTime();
      final Comparator<Ort> s_BlE = (o1, o2) -> {
         int rt = 0;
         rt = o1.getBundesland().compareTo(o2.getBundesland());
         if (rt == 0) {
            rt = Integer.compare(o1.getEinwohnerzahl(), o2.getEinwohnerzahl());
         }
         return rt;
      };

      final Map<String, List<Ort>> map = plzListe.stream().sorted(s_BlE)
            .collect(Collectors.groupingBy(Ort::getBundesland));

      map.keySet().stream().forEach(key -> {
         System.out.format("--- %s --------------------%n", key);
         final List<Ort> bort = map.get(key);
         bort.stream().forEach(System.out::println);
      });
      final long time1 = Util.getTime(start);

      final Map<String, List<Ort>> map2 = plzListe.parallelStream()
            .sorted(s_BlE)
            .collect(Collectors.groupingByConcurrent(Ort::getBundesland));

      map2.keySet().stream().forEach(key -> {
         System.out.format("--- %s --------------------%n", key);
         final List<Ort> bort = map.get(key);
         bort.stream().forEach(System.out::println);
      });
      final long time2 = Util.getTime(start);

      System.out.println("#######################");
      Util.printDiff(time1, "erster", time2, "zweiter");
      System.out.println("Verwendete Kerne: " + Runtime.getRuntime().availableProcessors());
      // @formatter:on

   }

}