package de.gc.streams.komp;

import java.util.Map;
import java.util.stream.Collectors;

import de.gc.model.Ort;
import de.gc.model.PlzList;
import de.gc.util.Util;

public class Lamda_11_groupby_03 {

   public static void main(final String[] args) {
      final PlzList plzListe = new PlzList("/plz_orte.csv");

      // @formatter:off
      final long start = Util.getStartTime();
      final Map<String, Long> anzOrtB = plzListe.parallelStream()
            .unordered()
            .collect(Collectors.groupingByConcurrent(
                  Ort::getBundesland, Collectors.counting()));

      anzOrtB.forEach((bundesland, anzahl)
            -> System.out.format("%s : %d Orte%n", bundesland, anzahl));

      System.out.println("#######################");
      Util.printTime(start);
      // @formatter:on
   }
}